## harfbuzz 2.6.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.0)
project(harfbuzz)

enable_testing()

## Limit framework build to Xcode generator
if (BUILD_FRAMEWORK)
  # for a framework build on macOS, use:
  # cmake -DBUILD_FRAMEWORK=ON -Bbuild -H. -GXcode && cmake --build build
  if (NOT "${CMAKE_GENERATOR}" STREQUAL "Xcode")
    message(FATAL_ERROR
      "You should use Xcode generator with BUILD_FRAMEWORK enabled")
  endif ()
  set (CMAKE_OSX_ARCHITECTURES "$(ARCHS_STANDARD_32_64_BIT)")
  set (CMAKE_MACOSX_RPATH ON)
  set (BUILD_SHARED_LIBS ON)
endif ()


## Disallow in-source builds, as CMake generated make files can collide with autotools ones
if (NOT MSVC AND "${PROJECT_BINARY_DIR}" STREQUAL "${PROJECT_SOURCE_DIR}")
  message(FATAL_ERROR
    "
In-source builds are not permitted!  Make a separate folder for"
    " building, e.g.,"
    "
  mkdir build; cd build; cmake .."
    "
Before that, remove the files created by this failed run with"
    "
  rm -rf CMakeCache.txt CMakeFiles")
endif ()


## HarfBuzz build configurations
option(HB_HAVE_FREETYPE "Enable freetype interop helpers" OFF)
option(HB_HAVE_GRAPHITE2 "Enable Graphite2 complementary shaper" OFF)
option(HB_HAVE_GLIB "Enable glib unicode functions" OFF)
option(HB_HAVE_ICU "Enable icu unicode functions" OFF)
if (APPLE)
  option(HB_HAVE_CORETEXT "Enable CoreText shaper backend on macOS" ON)
  set (CMAKE_MACOSX_RPATH ON)
endif ()
if (WIN32)
  option(HB_HAVE_UNISCRIBE "Enable Uniscribe shaper backend on Windows" OFF)
  option(HB_HAVE_GDI "Enable GDI integration helpers on Windows" OFF)
  option(HB_HAVE_DIRECTWRITE "Enable DirectWrite shaper backend on Windows" OFF)
endif ()
option(HB_BUILD_UTILS "Build harfbuzz utils, needs cairo, freetype, and glib properly be installed" OFF)
if (HB_BUILD_UTILS)
  set (HB_HAVE_GLIB ON)
  set (HB_HAVE_FREETYPE ON)
endif ()

option(HB_BUILD_SUBSET "Build harfbuzz-subset" ON)
option(HB_BUILD_TESTS "Build harfbuzz tests" ON)

option(HB_HAVE_GOBJECT "Enable GObject Bindings" OFF)
if (HB_HAVE_GOBJECT)
  set (HB_HAVE_GLIB ON)
endif ()

option(HB_HAVE_INTROSPECTION "Enable building introspection (.gir/.typelib) files" OFF)
if (HB_HAVE_INTROSPECTION)
  set (HB_HAVE_GOBJECT ON)
  set (HB_HAVE_GLIB ON)
endif ()

option(HB_CHECK OFF "Do a configuration suitable for testing (shared library and enable all options)")
if (HB_CHECK)
  set (BUILD_SHARED_LIBS ON)
  set (HB_BUILD_UTILS ON)
  set (HB_HAVE_ICU)
  set (HB_HAVE_GLIB ON)
  #set (HB_HAVE_GOBJECT ON)
  #set (HB_HAVE_INTROSPECTION ON)
  set (HB_HAVE_FREETYPE ON)
  set (HB_HAVE_GRAPHITE2 ON)
  if (WIN32)
    set (HB_HAVE_UNISCRIBE ON)
    set (HB_HAVE_GDI ON)
    set (HB_HAVE_DIRECTWRITE ON)
  elseif (APPLE)
    set (HB_HAVE_CORETEXT ON)
  endif ()
endif ()

include_directories(AFTER
  ${PROJECT_SOURCE_DIR}/src
  ${PROJECT_BINARY_DIR}/src
)

# We need PYTHON_EXECUTABLE to be set for running the tests...
include (FindPythonInterp)

## Functions and headers
include (CheckFunctionExists)
include (CheckIncludeFile)
macro (check_funcs) # Similar to AC_CHECK_FUNCS of autotools
  foreach (func_name ${ARGN})
    string(TOUPPER ${func_name} definition_to_add)
    check_function_exists(${func_name} HAVE_${definition_to_add})
    if (${HAVE_${definition_to_add}})
      add_definitions(-DHAVE_${definition_to_add})
    endif ()
  endforeach ()
endmacro ()
if (UNIX)
  list(APPEND CMAKE_REQUIRED_LIBRARIES m)
endif ()
check_funcs(atexit mprotect sysconf getpagesize mmap isatty newlocale strtod_l roundf)
check_include_file(unistd.h HAVE_UNISTD_H)
if (${HAVE_UNISTD_H})
  add_definitions(-DHAVE_UNISTD_H)
endif ()
check_include_file(sys/mman.h HAVE_SYS_MMAN_H)
if (${HAVE_SYS_MMAN_H})
  add_definitions(-DHAVE_SYS_MMAN_H)
endif ()
check_include_file(xlocale.h HAVE_XLOCALE_H)
if (${HAVE_XLOCALE_H})
  add_definitions(-DHAVE_XLOCALE_H)
endif ()
check_include_file(stdbool.h HAVE_STDBOOL_H)
if (${HAVE_STDBOOL_H})
  add_definitions(-DHAVE_STDBOOL_H)
endif ()


if (MSVC)
  add_definitions(-wd4244 -wd4267 -D_CRT_SECURE_NO_WARNINGS -D_CRT_NONSTDC_NO_WARNINGS)
endif ()


## Detect if we are running inside a distribution or regular repository folder
# if (EXISTS "${PROJECT_SOURCE_DIR}/ChangeLog")
#   # perhaps we are on dist directory
#   set (IN_HB_DIST TRUE)
#   #set (HB_VERSION_H "${PROJECT_SOURCE_DIR}/src/hb-version.h")
# endif ()


## Extract variables from Makefile files
function (extract_make_variable variable makefile_source)
  string(REGEX MATCH "${variable} = ([^$]+)\\$" temp "${makefile_source}")
  string(REGEX MATCHALL "[^ \n\t\\]+" listVar "${CMAKE_MATCH_1}")
  set (${variable} ${listVar} PARENT_SCOPE)
endfunction ()

# http://stackoverflow.com/a/27630120
function (add_prefix_to_list var prefix)
  set (listVar "")
  foreach (f ${${var}})
    list(APPEND listVar "${prefix}${f}")
  endforeach ()
  set (${var} "${listVar}" PARENT_SCOPE)
endfunction ()

file(READ ${PROJECT_SOURCE_DIR}/src/Makefile.sources SRCSOURCES)
file(READ ${PROJECT_SOURCE_DIR}/util/Makefile.sources UTILSOURCES)

extract_make_variable(HB_BASE_headers ${SRCSOURCES})
add_prefix_to_list(HB_BASE_headers "${PROJECT_SOURCE_DIR}/src/")

extract_make_variable(HB_SUBSET_sources ${SRCSOURCES})
add_prefix_to_list(HB_SUBSET_sources "${PROJECT_SOURCE_DIR}/src/")

extract_make_variable(HB_SUBSET_headers ${SRCSOURCES})
add_prefix_to_list(HB_SUBSET_headers "${PROJECT_SOURCE_DIR}/src/")

extract_make_variable(HB_BASE_RAGEL_GENERATED_sources ${SRCSOURCES})
#if (IN_HB_DIST)
  add_prefix_to_list(HB_BASE_RAGEL_GENERATED_sources "${PROJECT_SOURCE_DIR}/src/")
#else ()
#  add_prefix_to_list(HB_BASE_RAGEL_GENERATED_sources "${PROJECT_BINARY_DIR}/src/")
#endif ()

extract_make_variable(HB_VIEW_sources ${UTILSOURCES})
add_prefix_to_list(HB_VIEW_sources "${PROJECT_SOURCE_DIR}/util/")
extract_make_variable(HB_SHAPE_sources ${UTILSOURCES})
add_prefix_to_list(HB_SHAPE_sources "${PROJECT_SOURCE_DIR}/util/")
extract_make_variable(HB_SUBSET_CLI_sources ${UTILSOURCES})
add_prefix_to_list(HB_SUBSET_CLI_sources "${PROJECT_SOURCE_DIR}/util/")
extract_make_variable(HB_OT_SHAPE_CLOSURE_sources ${UTILSOURCES})
add_prefix_to_list(HB_OT_SHAPE_CLOSURE_sources "${PROJECT_SOURCE_DIR}/util/")


file(READ configure.ac CONFIGUREAC)
string(REGEX MATCH "\\[(([0-9]+)\\.([0-9]+)\\.([0-9]+))\\]" HB_VERSION_MATCH ${CONFIGUREAC})
set (HB_VERSION ${CMAKE_MATCH_1})
set (HB_VERSION_MAJOR ${CMAKE_MATCH_2})
set (HB_VERSION_MINOR ${CMAKE_MATCH_3})
set (HB_VERSION_MICRO ${CMAKE_MATCH_4})

## Define sources and headers of the project
set (project_sources ${PROJECT_SOURCE_DIR}/src/harfbuzz.cc) # use amalgam source
set (subset_project_sources ${HB_SUBSET_sources})
set (project_extra_sources)
set (project_headers ${HB_BASE_headers})
set (subset_project_headers ${HB_SUBSET_headers})

## Find and include needed header folders and libraries
if (HB_HAVE_FREETYPE)
  include (FindFreetype)
  if (NOT FREETYPE_FOUND)
    message(FATAL_ERROR "HB_HAVE_FREETYPE was set, but we failed to find it. Maybe add a CMAKE_PREFIX_PATH= to your Freetype2 install prefix")
  endif ()

  list(APPEND THIRD_PARTY_LIBS ${FREETYPE_LIBRARIES})
  include_directories(AFTER ${FREETYPE_INCLUDE_DIRS})
  add_definitions(-DHAVE_FREETYPE=1)

  list(APPEND project_headers ${PROJECT_SOURCE_DIR}/src/hb-ft.h)

  # So check_funcs can find its headers
  set (CMAKE_REQUIRED_INCLUDES ${CMAKE_REQUIRED_INCLUDES} ${FREETYPE_INCLUDE_DIRS})
  set (CMAKE_REQUIRED_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES} ${FREETYPE_LIBRARIES})

  check_funcs(FT_Get_Var_Blend_Coordinates FT_Set_Var_Blend_Coordinates FT_Done_MM_Var)
endif ()

if (HB_HAVE_GRAPHITE2)
  add_definitions(-DHAVE_GRAPHITE2)

  find_path(GRAPHITE2_INCLUDE_DIR graphite2/Font.h)
  find_library(GRAPHITE2_LIBRARY graphite2)

  include_directories(${GRAPHITE2_INCLUDE_DIR})

  list(APPEND project_headers ${PROJECT_SOURCE_DIR}/src/hb-graphite2.h)

  list(APPEND THIRD_PARTY_LIBS ${GRAPHITE2_LIBRARY})

  mark_as_advanced(GRAPHITE2_INCLUDE_DIR GRAPHITE2_LIBRARY)
endif ()

if (HB_HAVE_GLIB)
  add_definitions(-DHAVE_GLIB)

  # https://github.com/WebKit/webkit/blob/master/Source/cmake/FindGLIB.cmake
  find_package(PkgConfig)
  pkg_check_modules(PC_GLIB QUIET glib-2.0)

  find_library(GLIB_LIBRARIES NAMES glib-2.0 HINTS ${PC_GLIB_LIBDIR} ${PC_GLIB_LIBRARY_DIRS})
  find_path(GLIBCONFIG_INCLUDE_DIR NAMES glibconfig.h HINTS ${PC_LIBDIR} ${PC_LIBRARY_DIRS} ${PC_GLIB_INCLUDEDIR} ${PC_GLIB_INCLUDE_DIRS} PATH_SUFFIXES glib-2.0/include)
  find_path(GLIB_INCLUDE_DIR NAMES glib.h HINTS ${PC_GLIB_INCLUDEDIR} ${PC_GLIB_INCLUDE_DIRS} PATH_SUFFIXES glib-2.0)

  include_directories(${GLIBCONFIG_INCLUDE_DIR} ${GLIB_INCLUDE_DIR})

  list(APPEND project_headers ${PROJECT_SOURCE_DIR}/src/hb-glib.h)

  list(APPEND THIRD_PARTY_LIBS ${GLIB_LIBRARIES})

  mark_as_advanced(GLIB_LIBRARIES GLIBCONFIG_INCLUDE_DIR GLIB_INCLUDE_DIR)
endif ()

if (HB_HAVE_ICU)
  add_definitions(-DHAVE_ICU)

  # https://github.com/WebKit/webkit/blob/master/Source/cmake/FindICU.cmake
  find_package(PkgConfig)
  pkg_check_modules(PC_ICU QUIET icu-uc)

  find_path(ICU_INCLUDE_DIR NAMES unicode/utypes.h HINTS ${PC_ICU_INCLUDE_DIRS} ${PC_ICU_INCLUDEDIR})
  find_library(ICU_LIBRARY NAMES libicuuc cygicuuc cygicuuc32 icuuc HINTS ${PC_ICU_LIBRARY_DIRS} ${PC_ICU_LIBDIR})

  include_directories(${ICU_INCLUDE_DIR})

  list(APPEND project_headers ${PROJECT_SOURCE_DIR}/src/hb-icu.h)

  list(APPEND THIRD_PARTY_LIBS ${ICU_LIBRARY})

  mark_as_advanced(ICU_INCLUDE_DIR ICU_LIBRARY)
endif ()

if (APPLE AND HB_HAVE_CORETEXT)
  # Apple Advanced Typography
  add_definitions(-DHAVE_CORETEXT)

  list(APPEND project_headers ${PROJECT_SOURCE_DIR}/src/hb-coretext.h)

  if (HB_IOS)
    find_library(COREFOUNDATION CoreFoundation)
    if (COREFOUNDATION)
      list(APPEND THIRD_PARTY_LIBS ${COREFOUNDATION})
    endif ()
    mark_as_advanced(COREFOUNDATION)

    find_library(CORETEXT CoreText)
    if (CORETEXT)
      list(APPEND THIRD_PARTY_LIBS ${CORETEXT})
    endif ()
    mark_as_advanced(CORETEXT)

    find_library(COREGRAPHICS CoreGraphics)
    if (COREGRAPHICS)
      list(APPEND THIRD_PARTY_LIBS ${COREGRAPHICS})
    endif ()
    mark_as_advanced(COREGRAPHICS)
  else ()
    find_library(APPLICATION_SERVICES_FRAMEWORK ApplicationServices)
    if (APPLICATION_SERVICES_FRAMEWORK)
      list(APPEND THIRD_PARTY_LIBS ${APPLICATION_SERVICES_FRAMEWORK})
    endif ()

    mark_as_advanced(APPLICATION_SERVICES_FRAMEWORK)
  endif ()
endif ()

if (WIN32 AND HB_HAVE_GDI)
  add_definitions(-DHAVE_GDI)
  list(APPEND project_headers ${PROJECT_SOURCE_DIR}/src/hb-gdi.h)
  list(APPEND THIRD_PARTY_LIBS gdi32)
endif ()

if (WIN32 AND HB_HAVE_UNISCRIBE)
  add_definitions(-DHAVE_UNISCRIBE)
  list(APPEND project_headers ${PROJECT_SOURCE_DIR}/src/hb-uniscribe.h)
  list(APPEND THIRD_PARTY_LIBS usp10 gdi32 rpcrt4)
endif ()

if (WIN32 AND HB_HAVE_DIRECTWRITE)
  add_definitions(-DHAVE_DIRECTWRITE)
  list(APPEND project_headers ${PROJECT_SOURCE_DIR}/src/hb-directwrite.h)
  list(APPEND THIRD_PARTY_LIBS dwrite rpcrt4)
endif ()

if (HB_HAVE_GOBJECT)
  include (FindPerl)

  # Use the hints from glib-2.0.pc to find glib-mkenums
  find_package(PkgConfig)
  pkg_check_modules(PC_GLIB QUIET glib-2.0)
  find_program(GLIB_MKENUMS glib-mkenums
    HINTS ${PC_glib_mkenums}
  )
  set (GLIB_MKENUMS_CMD)

  if (WIN32 AND NOT MINGW)
    # In Visual Studio builds, shebang lines are not supported
    # in the standard cmd.exe shell that we use, so we need to
    # first determine whether glib-mkenums is a Python or PERL
    # script
    execute_process(COMMAND "${PYTHON_EXECUTABLE}" "${GLIB_MKENUMS}" --version
      RESULT_VARIABLE GLIB_MKENUMS_PYTHON
      OUTPUT_QUIET ERROR_QUIET
    )
    if (GLIB_MKENUMS_PYTHON EQUAL 0)
      message("${GLIB_MKENUMS} is a Python script.")
      set (GLIB_MKENUMS_CMD "${PYTHON_EXECUTABLE}" "${GLIB_MKENUMS}")
    else ()
      execute_process(COMMAND "${PERL_EXECUTABLE}" "${GLIB_MKENUMS}" --version
        RESULT_VARIABLE GLIB_MKENUMS_PERL
        OUTPUT_QUIET ERROR_QUIET
      )
      if (GLIB_MKENUMS_PERL EQUAL 0)
        message("${GLIB_MKENUMS} is a PERL script.")

=== test/CMakeLists.txt ===
add_subdirectory(api)
add_subdirectory(shaping)
add_subdirectory(subset)
add_subdirectory(fuzzing)

=== test/api/CMakeLists.txt ===
if (HB_HAVE_GLIB)
  file (READ "${CMAKE_CURRENT_SOURCE_DIR}/Makefile.am" MAKEFILEAM)
  extract_make_variable (TEST_PROGS ${MAKEFILEAM})

  list (APPEND TEST_PROGS
    test-ot-color
    test-ot-name
    test-ot-tag
    test-c
    test-cplusplus
  )

  if (HB_HAVE_FREETYPE)
    list (APPEND TEST_PROGS test-ot-math)
  endif ()

  foreach (test_name IN ITEMS ${TEST_PROGS})
    if (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/${test_name}.c)
      add_executable (${test_name} ${test_name}.c)
    elseif (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/${test_name}.cc)
      add_executable (${test_name} ${test_name}.cc)
    else ()
      message (FATAL_ERROR "No source file found for test ${test_name}")
    endif ()
    target_link_libraries (${test_name} harfbuzz harfbuzz-subset)
    if (WIN32)
      set_property (TARGET ${test_name} PROPERTY RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
      add_test (NAME ${test_name} COMMAND ${test_name})
    else (WIN32)
      add_test (${test_name} ${test_name})
    endif (WIN32)
  endforeach ()
  set_tests_properties (${TEST_PROGS} PROPERTIES ENVIRONMENT
    "G_TEST_SRCDIR=${CMAKE_CURRENT_SOURCE_DIR};G_TEST_BUILDDIR=${CMAKE_CURRENT_BINARY_DIR}"
  )
endif ()

=== test/shaping/CMakeLists.txt ===
if (HB_BUILD_UTILS)
  file (READ "${CMAKE_CURRENT_SOURCE_DIR}/data/in-house/Makefile.sources" INHOUSE)
  extract_make_variable (TESTS ${INHOUSE})
  foreach (test IN ITEMS ${TESTS})
    add_test (NAME ${test}
      COMMAND "${PYTHON_EXECUTABLE}" run-tests.py $<TARGET_FILE:hb-shape> "data/in-house/${test}"
      WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
    set_property (TEST ${test} PROPERTY SKIP_RETURN_CODE 77)
  endforeach ()

  file (READ "${CMAKE_CURRENT_SOURCE_DIR}/data/aots/Makefile.sources" INHOUSE)
  extract_make_variable (TESTS ${INHOUSE})
  foreach (test IN ITEMS ${TESTS})
    add_test (NAME ${test}
      COMMAND "${PYTHON_EXECUTABLE}" run-tests.py $<TARGET_FILE:hb-shape> "data/aots/${test}"
      WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
    set_property (TEST ${test} PROPERTY SKIP_RETURN_CODE 77)
  endforeach ()

  file (READ "${CMAKE_CURRENT_SOURCE_DIR}/data/text-rendering-tests/Makefile.sources" TEXTRENDERING)
  extract_make_variable (TESTS ${TEXTRENDERING})
  foreach (test IN ITEMS ${TESTS})
    add_test (NAME ${test}
      COMMAND "${PYTHON_EXECUTABLE}" run-tests.py $<TARGET_FILE:hb-shape> "data/text-rendering-tests/${test}"
      WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
    set_property (TEST ${test} PROPERTY SKIP_RETURN_CODE 77)
  endforeach ()
endif ()

=== debian/changelog ===
harfbuzz (2.6.4-1ubuntu4) focal; urgency=medium

  * Increase slow new fuzzer test timeouts for riscv64.

 -- William Grant <wgrant@ubuntu.com>  Tue, 31 Mar 2020 17:01:35 +1100

harfbuzz (2.6.4-1ubuntu3) focal; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 03 Mar 2020 21:32:53 +0100

harfbuzz (2.6.4-1ubuntu2) focal; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 13 Feb 2020 08:58:26 +0100

harfbuzz (2.6.4-1ubuntu1) focal; urgency=medium

  * Make autopkgtests cross-test-friendly.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 08 Dec 2019 21:37:05 -0800

harfbuzz (2.6.4-1) unstable; urgency=medium

  * Imported Upstream version 2.6.4
  * Add Rules-Requires-Root: no
  * Update symbols file

 -- أحمد المحمودي (Ahmed El-Mahmoudy) <aelmahmoudy@users.sourceforge.net>  Sun, 03 Nov 2019 03:37:28 +0100

harfbuzz (2.6.2-1) unstable; urgency=medium

  * Imstall cmake file in libharfbuzz-dev
  * Revert "Add separate dh_makeshlibs call for the udeb"
    This reverts commit a4bbcc06c858fb5f1e07dca96fc2eee32819036d.
  * Add d/not-installed to list deliberately non-installed files
  * Imported Upstream version 2.6.2
  * Update standards version to 4.4.1

 -- أحمد المحمودي (Ahmed El-Mahmoudy) <aelmahmoudy@users.sourceforge.net>  Thu, 03 Oct 2019 06:06:33 +0200

=== debian/control ===
Source: harfbuzz
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: أحمد المحمودي (Ahmed El-Mahmoudy) <aelmahmoudy@users.sourceforge.net>
Uploaders: Emilio Pozuelo Monfort <pochu@debian.org>
Standards-Version: 4.4.1
Build-Depends:
 debhelper (>= 12),
 pkg-config,
 libglib2.0-dev (>= 2.19.1),
 libcairo2-dev,
 libfreetype6-dev,
 libicu-dev,
 libgraphite2-dev,
 libgirepository1.0-dev (>= 1.31.0-2),
 gobject-introspection (>= 1.42.0),
 gtk-doc-tools (>= 1.15),
 python3:any
Rules-Requires-Root: no
Homepage: https://www.freedesktop.org/wiki/Software/HarfBuzz
Vcs-Git: https://salsa.debian.org/freedesktop-team/harfbuzz.git
Vcs-Browser: https://salsa.debian.org/freedesktop-team/harfbuzz

Package: libharfbuzz0b
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: libharfbuzz0, libharfbuzz0a
Replaces: libharfbuzz0, libharfbuzz0a
Pre-Depends: ${misc:Pre-Depends}
Description: OpenType text shaping engine (shared library)
 HarfBuzz is an implementation of the OpenType Layout engine (aka layout
 engine) and the script-specific logic (aka shaping engine).
 .
 This package contains the shared libraries.

Package: libharfbuzz-gobject0
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: OpenType text shaping engine ICU backend (GObject library)
 HarfBuzz is an implementation of the OpenType Layout engine (aka layout
 engine) and the script-specific logic (aka shaping engine).
 .
 This package contains the GObject library, providing wrapper GObject type
 bindings for all HarfBuzz objects and enums.

Package: gir1.2-harfbuzz-0.0
Section: introspection
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, ${gir:Depends}
Description: OpenType text shaping engine (GObject introspection data)
 HarfBuzz is an implementation of the OpenType Layout engine (aka layout
 engine) and the script-specific logic (aka shaping engine).
 .
 This package contains introspection data for the GObject bindings library.

Package: libharfbuzz-icu0
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: OpenType text shaping engine ICU backend
 HarfBuzz is an implementation of the OpenType Layout engine (aka layout
 engine) and the script-specific logic (aka shaping engine).
 .
 This package contains the ICU backend.

Package: libharfbuzz-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 ${misc:Depends},
 libharfbuzz0b (= ${binary:Version}),
 libharfbuzz-icu0 (= ${binary:Version}),
 libharfbuzz-gobject0 (= ${binary:Version}),
 gir1.2-harfbuzz-0.0 (= ${binary:Version}),
 libglib2.0-dev (>= 2.19.1),
 libgraphite2-dev,
 libicu-dev,
Description: Development files for OpenType text shaping engine
 HarfBuzz is an implementation of the OpenType Layout engine (aka layout
 engine) and the script-specific logic (aka shaping engine).
 .
 This package contains the header files and static libraries for the
 HarfBuzz library.

Package: libharfbuzz-bin
Architecture: any
Section: utils
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: OpenType text shaping engine (utility)
 HarfBuzz is an implementation of the OpenType Layout engine (aka layout
 engine) and the script-specific logic (aka shaping engine).
 .
 This package contains a command line interface for the HarfBuzz library.

Package: libharfbuzz-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: Documentation files for the HarfBuzz library
 HarfBuzz is an implementation of the OpenType Layout engine (aka layout
 engine) and the script-specific logic (aka shaping engine).
 .
 This package contains the HTML documentation for the HarfBuzz library.

Package: libharfbuzz0-udeb
Package-Type: udeb
Architecture: any
Section: debian-installer
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: OpenType text shaping engine
 HarfBuzz is an implementation of the OpenType Layout engine (aka layout
 engine) and the script-specific logic (aka shaping engine).

=== debian/rules ===
#!/usr/bin/make -f

# Needed for glib-mkenums to work with UTF-8 input
export LC_ALL=C.UTF-8

# Increase slow fuzzer test timeouts for riscv64.
export HB_TEST_SHAPE_FUZZER_TIMEOUT=10
export HB_TEST_SUBSET_FUZZER_TIMEOUT=20

%:
	dh $@ --with gir

override_dh_auto_configure:
	dh_auto_configure --builddir build-main -- --with-graphite2=yes --enable-introspection --with-gobject --enable-gtk-doc --enable-static
	dh_auto_configure --builddir build-udeb -- --with-graphite2=no

override_dh_auto_clean:
	dh_auto_clean --builddir build-main
	dh_auto_clean --builddir build-udeb

override_dh_auto_build:
	dh_auto_build --builddir build-main
	dh_auto_build --builddir build-udeb

override_dh_auto_test:
	dh_auto_test --builddir build-main
	dh_auto_test --builddir build-udeb

override_dh_auto_install:
	dh_auto_install --builddir build-main

override_dh_install:
	dh_install -Xsubset

override_dh_makeshlibs:
	dh_makeshlibs -V --add-udeb="libharfbuzz0-udeb" -- -c4

=== debian/watch ===
version=3
https://www.freedesktop.org/software/harfbuzz/release/harfbuzz-([\d\.]+)\.tar\.(?:xz|bz2|gz)

## harfbuzz 2.6.4-1ubuntu4.2~bpo18.04.1~lo1+9.0trisquel1

=== debian/changelog ===
harfbuzz (2.6.4-1ubuntu4.2~bpo18.04.1~lo1+9.0trisquel1) etiona-backports; urgency=medium

  * Backported into Trisquel as a dependency of libreoffice (fresh)

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Tue, 27 Sep 2022 05:40:15 +0000

harfbuzz (2.6.4-1ubuntu4.2~bpo18.04.1~lo1) bionic; urgency=medium

  * No-change backport to bionic.

 -- Rico Tzschichholz <ricotz@ubuntu.com>  Sat, 10 Sep 2022 22:22:21 +0200

harfbuzz (2.6.4-1ubuntu4.2) focal-security; urgency=medium

  * SECURITY UPDATE: DoS via integer overflow
    - debian/patches/CVE-2022-33068-1.patch: limit glyph extents in
      src/hb-ot-color-sbix-table.hh.
    - debian/patches/CVE-2022-33068-2.patch: fix conditional in
      src/hb-ot-color-sbix-table.hh.
    - CVE-2022-33068
  * debian/rules: increase fuzzer timeouts to fix FTBFS on riscv64.

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 13 Jul 2022 12:43:13 -0400

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: harfbuzz
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
 XSBC-Original-Maintainer: أحمد المحمودي (Ahmed El-Mahmoudy) <aelmahmoudy@users.sourceforge.net>
 Uploaders: Emilio Pozuelo Monfort <pochu@debian.org>
 Standards-Version: 4.4.1

## harfbuzz 2.6.7

=== debian/changelog ===
harfbuzz (2.6.7-1mx19+1) mx; urgency=medium

  * Rebuild for MX-19.

 -- Mike Purtell <mmikeinsantarosa@mxlinux.org>  Sun, 27 Sep 2020 18:23:07 -0700

harfbuzz (2.6.7-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Use correct machine-readable copyright file URI.
  * Set debhelper-compat version in Build-Depends.
  * Set upstream metadata fields: Repository.
  * Update standards version to 4.5.0, no changes needed.

  [ أحمد المحمودي (Ahmed El-Mahmoudy) ]
  * New upstream version 2.6.7
  * Dropped py3.diff patch, applied upstream
  * Update symbols
  * Bumped compat level to 13
  * Add libfreetype2-dev to deps of libharfbuzz-dev

 -- أحمد المحمودي (Ahmed El-Mahmoudy) <aelmahmoudy@users.sourceforge.net>  Sat, 13 Jun 2020 15:28:02 +0200

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,10 @@
 Source: harfbuzz
 Section: libs
 Priority: optional
-Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
+Maintainer: Mike Purtell <mmikeinsantarosa@mxlinux.org>
 XSBC-Original-Maintainer: أحمد المحمودي (Ahmed El-Mahmoudy) <aelmahmoudy@users.sourceforge.net>
 Uploaders: Emilio Pozuelo Monfort <pochu@debian.org>
-Standards-Version: 4.4.1
+Standards-Version: 4.5.0
 Build-Depends:
  debhelper (>= 12),
  pkg-config,
@@ -82,6 +82,7 @@
  libglib2.0-dev (>= 2.19.1),
  libgraphite2-dev,
  libicu-dev,
+ libfreetype6-dev,
 Description: Development files for OpenType text shaping engine
  HarfBuzz is an implementation of the OpenType Layout engine (aka layout
  engine) and the script-specific logic (aka shaping engine).

=== debian/rules ===
--- 
+++ 
@@ -2,10 +2,6 @@
 
 # Needed for glib-mkenums to work with UTF-8 input
 export LC_ALL=C.UTF-8
-
-# Increase slow fuzzer test timeouts for riscv64.
-export HB_TEST_SHAPE_FUZZER_TIMEOUT=10
-export HB_TEST_SUBSET_FUZZER_TIMEOUT=20
 
 %:
 	dh $@ --with gir
@@ -30,7 +26,11 @@
 	dh_auto_install --builddir build-main
 
 override_dh_install:
-	dh_install -Xsubset
+	dh_install --exclude=subset
 
 override_dh_makeshlibs:
-	dh_makeshlibs -V --add-udeb="libharfbuzz0-udeb" -- -c4
+	dh_makeshlibs --version-info --add-udeb="libharfbuzz0-udeb" -- -c4
+
+override_dh_strip:
+	dh_strip --no-automatic-dbgsym
+

## harfbuzz 2.7.4

=== debian/changelog ===
harfbuzz (2.7.4-1ubuntu3.2) jammy-security; urgency=medium

  * SECURITY UPDATE: resource consumption via consecutive marks
    - debian/patches/CVE-2023-25193-pre1.patch: refactor
      skippy_iter.match() in src/hb-ot-layout-gsubgpos.hh.
    - debian/patches/CVE-2023-25193-1.patch: avoid O(n^2) behavior in
      mark-attachment in src/hb-ot-layout-gsubgpos.hh,
      src/hb-ot-layout-gpos-table.hh.
    - debian/patches/CVE-2023-25193-2.patch: optimize
      _infos_set_glyph_flags to avoid O(n^2) behavior in src/hb-buffer.hh.
    - debian/patches/CVE-2023-25193-3.patch: fix up previous commit in
      src/hb-buffer.hh.
    - debian/patches/CVE-2023-25193-4.patch: fix assert fail introduced
      recently in src/hb-ot-layout-gpos-table.hh.
    - CVE-2023-25193

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Thu, 30 Jan 2025 13:07:47 -0500

harfbuzz (2.7.4-1ubuntu3.1) jammy-security; urgency=medium

  * SECURITY UPDATE: DoS via integer overflow
    - debian/patches/CVE-2022-33068-1.patch: limit glyph extents in
      src/hb-ot-color-sbix-table.hh.
    - debian/patches/CVE-2022-33068-2.patch: fix conditional in
      src/hb-ot-color-sbix-table.hh.
    - CVE-2022-33068

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 13 Jul 2022 12:40:13 -0400

harfbuzz (2.7.4-1ubuntu3) jammy; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 09 Feb 2022 05:39:28 +0100

harfbuzz (2.7.4-1ubuntu2) impish; urgency=medium

  * No-change rebuild to build packages with zstd compression.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 07 Oct 2021 12:12:34 +0200

harfbuzz (2.7.4-1ubuntu1) hirsute; urgency=medium

  * Merge with Debian; remaining changes:

 -- Matthias Klose <doko@ubuntu.com>  Thu, 04 Mar 2021 08:08:20 +0100

harfbuzz (2.7.4-1) unstable; urgency=medium

  * New upstream version.
  * Update symbols.

 -- Emilio Pozuelo Monfort <pochu@debian.org>  Mon, 18 Jan 2021 16:43:29 +0100

harfbuzz (2.6.7-1ubuntu2) hirsute; urgency=medium

  * No-change rebuild to drop the udeb package.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 22 Feb 2021 10:34:05 +0100

harfbuzz (2.6.7-1ubuntu1) hirsute; urgency=medium

  * Merge from Debian, remaining changes:
    - Make autopkgtests cross-test-friendly.
    - Increase slow new fuzzer test timeouts for riscv64.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 02 Nov 2020 12:33:18 +0000

harfbuzz (2.6.4-1ubuntu5) groovy; urgency=medium

  * No change rebuild against new icu ABI.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 27 Jul 2020 16:41:43 +0100

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,12 @@
 Source: harfbuzz
 Section: libs
 Priority: optional
-Maintainer: Mike Purtell <mmikeinsantarosa@mxlinux.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: أحمد المحمودي (Ahmed El-Mahmoudy) <aelmahmoudy@users.sourceforge.net>
 Uploaders: Emilio Pozuelo Monfort <pochu@debian.org>
 Standards-Version: 4.5.0
 Build-Depends:
- debhelper (>= 12),
+ debhelper-compat (= 13),
  pkg-config,
  libglib2.0-dev (>= 2.19.1),
  libcairo2-dev,

=== debian/rules ===
--- 
+++ 
@@ -2,6 +2,10 @@
 
 # Needed for glib-mkenums to work with UTF-8 input
 export LC_ALL=C.UTF-8
+
+# Increase slow fuzzer test timeouts for riscv64.
+export HB_TEST_SHAPE_FUZZER_TIMEOUT=10
+export HB_TEST_SUBSET_FUZZER_TIMEOUT=20
 
 %:
 	dh $@ --with gir
@@ -30,7 +34,3 @@
 
 override_dh_makeshlibs:
 	dh_makeshlibs --version-info --add-udeb="libharfbuzz0-udeb" -- -c4
-
-override_dh_strip:
-	dh_strip --no-automatic-dbgsym
-

=== debian/watch ===
version=3
https://github.com/harfbuzz/harfbuzz/releases \
	https://github.com/harfbuzz/harfbuzz/releases/download/.*/harfbuzz-([\d\.]+)\.tar\.(?:xz|bz2|gz)

## harfbuzz 5.2.0

=== debian/changelog ===
harfbuzz (5.2.0-2) unstable; urgency=medium

  * Team upload
  * Release to unstable

 -- Jeremy Bicha <jbicha@ubuntu.com>  Thu, 22 Sep 2022 06:28:46 -0400

harfbuzz (5.2.0-1) experimental; urgency=medium

  * Team upload
  * New upsream release

 -- Jeremy Bicha <jbicha@ubuntu.com>  Sat, 17 Sep 2022 09:13:45 -0400

harfbuzz (5.1.0-1) experimental; urgency=medium

  * Team upload

  [ Jeremy Bicha ]
  * New upstream release (Closes: #1010435)
    - Includes fix for CVE-2022-33068 (Closes: #1013673)
  * Build with meson
  * Build-Depend on dh-sequence-gir
  * Build-Depend on libchafa-dev
  * debian/*.symbols: Add new symbols
  * debian/libharfbuzz0b.docs: TODO is no longer provided
  * Add debian/gbp.conf
  * Enable all hardening flags
  * Bump Standards-Version to 4.6.1

  [ Laurent Bigonville ]
  * debian/control.in: Switch dependencies from libfreetype6-dev to
    libfreetype-dev

  [ Simon McVittie ]
  * Update upstream metadata to point to repository on Github

  [ Steve Langasek ]
  * debian/tests/build: Make cross-test-friendly

 -- Jeremy Bicha <jbicha@ubuntu.com>  Thu, 15 Sep 2022 17:14:37 -0400

## harfbuzz 6.0.0

=== debian/changelog ===
harfbuzz (6.0.0-1) unstable; urgency=medium

  * Team upload
  * New upstream release
  * Drop patch applied in new release

 -- Jeremy Bicha <jbicha@ubuntu.com>  Wed, 28 Dec 2022 07:34:07 -0900

harfbuzz (5.3.1-2) unstable; urgency=medium

  * Cherry-pick patch to fix build test when built with LTO

 -- Jeremy Bicha <jbicha@ubuntu.com>  Thu, 15 Dec 2022 08:20:37 -0500

harfbuzz (5.3.1-1) unstable; urgency=medium

  * Team upload
  * New upstream release
  * debian/libharfbuzz0b.symbols: Add new symbols

 -- Jeremy Bicha <jbicha@ubuntu.com>  Tue, 13 Dec 2022 08:55:50 -0500

## harfbuzz 6.0.0%2Bdfsg

=== debian/changelog ===
harfbuzz (6.0.0+dfsg-3) unstable; urgency=medium

  * Team upload
  * Update standards version to 4.6.2, no changes needed
  * Release to unstable

 -- Jeremy Bicha <jbicha@ubuntu.com>  Wed, 01 Feb 2023 16:47:11 -0500

harfbuzz (6.0.0+dfsg-2) experimental; urgency=medium

  * Team upload

  * Add a libharfbuzz-subset0 package (closes: #988781).

 -- Andres Salomon <dilinger@debian.org>  Mon, 30 Jan 2023 12:28:44 -0500

harfbuzz (6.0.0+dfsg-1) unstable; urgency=medium

  [ Andres Salomon ]
  * Use Files-Excluded to exclude non-free test fonts
    and generate a new tarball
  * Update debian/copyright for numerous font licenses and copyright holders

 -- Jeremy Bicha <jbicha@ubuntu.com>  Mon, 30 Jan 2023 11:44:28 -0500

## harfbuzz 6.0.0+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
-cmake_minimum_required(VERSION 2.8.0)
+cmake_minimum_required(VERSION 3.12)
 project(harfbuzz)
 
-enable_testing()
+message(WARN "HarfBuzz has a Meson port and tries to migrate all the other build systems to it, please consider using it as we might remove our cmake port soon.")
 
 ## Limit framework build to Xcode generator
 if (BUILD_FRAMEWORK)
@@ -37,6 +37,10 @@
 option(HB_HAVE_GRAPHITE2 "Enable Graphite2 complementary shaper" OFF)
 option(HB_HAVE_GLIB "Enable glib unicode functions" OFF)
 option(HB_HAVE_ICU "Enable icu unicode functions" OFF)
+if (TARGET freetype)
+  set (HB_HAVE_FREETYPE ON)
+  add_definitions(-DHAVE_FREETYPE=1)
+endif ()
 if (APPLE)
   option(HB_HAVE_CORETEXT "Enable CoreText shaper backend on macOS" ON)
   set (CMAKE_MACOSX_RPATH ON)
@@ -53,7 +57,6 @@
 endif ()
 
 option(HB_BUILD_SUBSET "Build harfbuzz-subset" ON)
-option(HB_BUILD_TESTS "Build harfbuzz tests" ON)
 
 option(HB_HAVE_GOBJECT "Enable GObject Bindings" OFF)
 if (HB_HAVE_GOBJECT)
@@ -66,25 +69,6 @@
   set (HB_HAVE_GLIB ON)
 endif ()
 
-option(HB_CHECK OFF "Do a configuration suitable for testing (shared library and enable all options)")
-if (HB_CHECK)
-  set (BUILD_SHARED_LIBS ON)
-  set (HB_BUILD_UTILS ON)
-  set (HB_HAVE_ICU)
-  set (HB_HAVE_GLIB ON)
-  #set (HB_HAVE_GOBJECT ON)
-  #set (HB_HAVE_INTROSPECTION ON)
-  set (HB_HAVE_FREETYPE ON)
-  set (HB_HAVE_GRAPHITE2 ON)
-  if (WIN32)
-    set (HB_HAVE_UNISCRIBE ON)
-    set (HB_HAVE_GDI ON)
-    set (HB_HAVE_DIRECTWRITE ON)
-  elseif (APPLE)
-    set (HB_HAVE_CORETEXT ON)
-  endif ()
-endif ()
-
 include_directories(AFTER
   ${PROJECT_SOURCE_DIR}/src
   ${PROJECT_BINARY_DIR}/src
@@ -96,6 +80,7 @@
 ## Functions and headers
 include (CheckFunctionExists)
 include (CheckIncludeFile)
+include (CheckIncludeFiles)
 macro (check_funcs) # Similar to AC_CHECK_FUNCS of autotools
   foreach (func_name ${ARGN})
     string(TOUPPER ${func_name} definition_to_add)
@@ -108,7 +93,7 @@
 if (UNIX)
   list(APPEND CMAKE_REQUIRED_LIBRARIES m)
 endif ()
-check_funcs(atexit mprotect sysconf getpagesize mmap isatty newlocale strtod_l roundf)
+check_funcs(atexit mprotect sysconf getpagesize mmap isatty)
 check_include_file(unistd.h HAVE_UNISTD_H)
 if (${HAVE_UNISTD_H})
   add_definitions(-DHAVE_UNISTD_H)
@@ -117,15 +102,24 @@
 if (${HAVE_SYS_MMAN_H})
   add_definitions(-DHAVE_SYS_MMAN_H)
 endif ()
-check_include_file(xlocale.h HAVE_XLOCALE_H)
-if (${HAVE_XLOCALE_H})
-  add_definitions(-DHAVE_XLOCALE_H)
-endif ()
 check_include_file(stdbool.h HAVE_STDBOOL_H)
 if (${HAVE_STDBOOL_H})
   add_definitions(-DHAVE_STDBOOL_H)
 endif ()
 
+# These will be used while making pkg-config .pc files
+set(PC_REQUIRES_PRIV "")
+set(PC_LIBS_PRIV "")
+
+if (NOT MSVC)
+  set(THREADS_PREFER_PTHREAD_FLAG ON)
+  find_package(Threads)
+  if (CMAKE_USE_PTHREADS_INIT)
+    add_definitions("-DHAVE_PTHREAD")
+    list(APPEND THIRD_PARTY_LIBS Threads::Threads)
+    list(APPEND PC_LIBS_PRIV -pthread)
+  endif ()
+endif ()
 
 if (MSVC)
   add_definitions(-wd4244 -wd4267 -D_CRT_SECURE_NO_WARNINGS -D_CRT_NONSTDC_NO_WARNINGS)
@@ -147,7 +141,7 @@
   set (${variable} ${listVar} PARENT_SCOPE)
 endfunction ()
 
-# http://stackoverflow.com/a/27630120
+# https://stackoverflow.com/a/27630120
 function (add_prefix_to_list var prefix)
   set (listVar "")
   foreach (f ${${var}})
@@ -200,7 +194,7 @@
 set (subset_project_headers ${HB_SUBSET_headers})
 
 ## Find and include needed header folders and libraries
-if (HB_HAVE_FREETYPE)
+if (HB_HAVE_FREETYPE AND NOT TARGET freetype)
   include (FindFreetype)
   if (NOT FREETYPE_FOUND)
     message(FATAL_ERROR "HB_HAVE_FREETYPE was set, but we failed to find it. Maybe add a CMAKE_PREFIX_PATH= to your Freetype2 install prefix")
@@ -219,6 +213,10 @@
   check_funcs(FT_Get_Var_Blend_Coordinates FT_Set_Var_Blend_Coordinates FT_Done_MM_Var)
 endif ()
 
+if (HB_HAVE_FREETYPE)
+  list(APPEND PC_REQUIRES_PRIV "freetype2 >= 12.0.6")
+endif ()
+
 if (HB_HAVE_GRAPHITE2)
   add_definitions(-DHAVE_GRAPHITE2)
 
@@ -230,6 +228,8 @@
   list(APPEND project_headers ${PROJECT_SOURCE_DIR}/src/hb-graphite2.h)
 
   list(APPEND THIRD_PARTY_LIBS ${GRAPHITE2_LIBRARY})
+
+  list(APPEND PC_REQUIRES_PRIV "graphite2 >= 1.2.0")
 
   mark_as_advanced(GRAPHITE2_INCLUDE_DIR GRAPHITE2_LIBRARY)
 endif ()
@@ -251,13 +251,15 @@
 
   list(APPEND THIRD_PARTY_LIBS ${GLIB_LIBRARIES})
 
+  list(APPEND PC_REQUIRES_PRIV "glib-2.0 >= 2.19.1")
+
   mark_as_advanced(GLIB_LIBRARIES GLIBCONFIG_INCLUDE_DIR GLIB_INCLUDE_DIR)
 endif ()
 
 if (HB_HAVE_ICU)
   add_definitions(-DHAVE_ICU)
 
-  # https://github.com/WebKit/webkit/blob/master/Source/cmake/FindICU.cmake
+  # https://github.com/WebKit/webkit/blob/fdd7733f2f30eab7fe096a9791f98c60f62f49c0/Source/cmake/FindICU.cmake
   find_package(PkgConfig)
   pkg_check_modules(PC_ICU QUIET icu-uc)
 
@@ -283,24 +285,28 @@
     find_library(COREFOUNDATION CoreFoundation)
     if (COREFOUNDATION)
       list(APPEND THIRD_PARTY_LIBS ${COREFOUNDATION})
+      list(APPEND PC_LIBS_PRIV "-framework CoreFoundation")
     endif ()
     mark_as_advanced(COREFOUNDATION)
 
     find_library(CORETEXT CoreText)
     if (CORETEXT)
       list(APPEND THIRD_PARTY_LIBS ${CORETEXT})
+      list(APPEND PC_LIBS_PRIV "-framework CoreText")
     endif ()
     mark_as_advanced(CORETEXT)
 
     find_library(COREGRAPHICS CoreGraphics)
     if (COREGRAPHICS)
       list(APPEND THIRD_PARTY_LIBS ${COREGRAPHICS})
+      list(APPEND PC_LIBS_PRIV "-framework CoreGraphics")
     endif ()
     mark_as_advanced(COREGRAPHICS)
   else ()
     find_library(APPLICATION_SERVICES_FRAMEWORK ApplicationServices)
     if (APPLICATION_SERVICES_FRAMEWORK)
       list(APPEND THIRD_PARTY_LIBS ${APPLICATION_SERVICES_FRAMEWORK})
+      list(APPEND PC_LIBS_PRIV "-framework ApplicationServices")
     endif ()
 
     mark_as_advanced(APPLICATION_SERVICES_FRAMEWORK)
@@ -311,21 +317,31 @@
   add_definitions(-DHAVE_GDI)
   list(APPEND project_headers ${PROJECT_SOURCE_DIR}/src/hb-gdi.h)
   list(APPEND THIRD_PARTY_LIBS gdi32)
+  list(APPEND PC_LIBS_PRIV -lgdi32)
 endif ()
 
 if (WIN32 AND HB_HAVE_UNISCRIBE)
   add_definitions(-DHAVE_UNISCRIBE)
   list(APPEND project_headers ${PROJECT_SOURCE_DIR}/src/hb-uniscribe.h)
   list(APPEND THIRD_PARTY_LIBS usp10 gdi32 rpcrt4)
+  list(APPEND PC_LIBS_PRIV -lusp10 -lgdi32 -lrpcrt4)
 endif ()
 
 if (WIN32 AND HB_HAVE_DIRECTWRITE)
+  if (CMAKE_VERSION VERSION_GREATER 3.12)
+    check_include_files("windows.h;dwrite_1.h" HAVE_DWRITE_1_H LANGUAGE CXX)
+  else ()
+    check_include_files("windows.h;dwrite_1.h" HAVE_DWRITE_1_H)
+  endif ()
+  if (NOT HAVE_DWRITE_1_H)
+    message(FATAL_ERROR "DirectWrite was enabled explicitly, but required header is missing")
+  endif ()
   add_definitions(-DHAVE_DIRECTWRITE)
   list(APPEND project_headers ${PROJECT_SOURCE_DIR}/src/hb-directwrite.h)
-  list(APPEND THIRD_PARTY_LIBS dwrite rpcrt4)
 endif ()
 
 if (HB_HAVE_GOBJECT)
+  add_definitions(-DHAVE_GOBJECT)
   include (FindPerl)
 
   # Use the hints from glib-2.0.pc to find glib-mkenums
@@ -334,24 +350,3 @@
   find_program(GLIB_MKENUMS glib-mkenums
     HINTS ${PC_glib_mkenums}
   )
-  set (GLIB_MKENUMS_CMD)
-
-  if (WIN32 AND NOT MINGW)
-    # In Visual Studio builds, shebang lines are not supported
-    # in the standard cmd.exe shell that we use, so we need to
-    # first determine whether glib-mkenums is a Python or PERL
-    # script
-    execute_process(COMMAND "${PYTHON_EXECUTABLE}" "${GLIB_MKENUMS}" --version
-      RESULT_VARIABLE GLIB_MKENUMS_PYTHON
-      OUTPUT_QUIET ERROR_QUIET
-    )
-    if (GLIB_MKENUMS_PYTHON EQUAL 0)
-      message("${GLIB_MKENUMS} is a Python script.")
-      set (GLIB_MKENUMS_CMD "${PYTHON_EXECUTABLE}" "${GLIB_MKENUMS}")
-    else ()
-      execute_process(COMMAND "${PERL_EXECUTABLE}" "${GLIB_MKENUMS}" --version
-        RESULT_VARIABLE GLIB_MKENUMS_PERL
-        OUTPUT_QUIET ERROR_QUIET
-      )
-      if (GLIB_MKENUMS_PERL EQUAL 0)
-        message("${GLIB_MKENUMS} is a PERL script.")

=== debian/control ===
--- 
+++ 
@@ -1,22 +1,22 @@
 Source: harfbuzz
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: أحمد المحمودي (Ahmed El-Mahmoudy) <aelmahmoudy@users.sourceforge.net>
+Maintainer: أحمد المحمودي (Ahmed El-Mahmoudy) <aelmahmoudy@users.sourceforge.net>
 Uploaders: Emilio Pozuelo Monfort <pochu@debian.org>
-Standards-Version: 4.5.0
+Standards-Version: 4.6.1
 Build-Depends:
  debhelper-compat (= 13),
+ dh-sequence-gir,
+ meson (>= 0.55),
  pkg-config,
- libglib2.0-dev (>= 2.19.1),
+ libglib2.0-dev,
  libcairo2-dev,
- libfreetype6-dev,
+ libchafa-dev,
+ libfreetype-dev,
  libicu-dev,
  libgraphite2-dev,
- libgirepository1.0-dev (>= 1.31.0-2),
- gobject-introspection (>= 1.42.0),
- gtk-doc-tools (>= 1.15),
- python3:any
+ libgirepository1.0-dev,
+ gtk-doc-tools,
 Rules-Requires-Root: no
 Homepage: https://www.freedesktop.org/wiki/Software/HarfBuzz
 Vcs-Git: https://salsa.debian.org/freedesktop-team/harfbuzz.git
@@ -28,7 +28,6 @@
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Conflicts: libharfbuzz0, libharfbuzz0a
 Replaces: libharfbuzz0, libharfbuzz0a
-Pre-Depends: ${misc:Pre-Depends}
 Description: OpenType text shaping engine (shared library)
  HarfBuzz is an implementation of the OpenType Layout engine (aka layout
  engine) and the script-specific logic (aka shaping engine).
@@ -39,7 +38,6 @@
 Architecture: any
 Multi-Arch: same
 Depends: ${misc:Depends}, ${shlibs:Depends}
-Pre-Depends: ${misc:Pre-Depends}
 Description: OpenType text shaping engine ICU backend (GObject library)
  HarfBuzz is an implementation of the OpenType Layout engine (aka layout
  engine) and the script-specific logic (aka shaping engine).
@@ -79,10 +77,10 @@
  libharfbuzz-icu0 (= ${binary:Version}),
  libharfbuzz-gobject0 (= ${binary:Version}),
  gir1.2-harfbuzz-0.0 (= ${binary:Version}),
- libglib2.0-dev (>= 2.19.1),
+ libglib2.0-dev,
  libgraphite2-dev,
  libicu-dev,
- libfreetype6-dev,
+ libfreetype-dev,
 Description: Development files for OpenType text shaping engine
  HarfBuzz is an implementation of the OpenType Layout engine (aka layout
  engine) and the script-specific logic (aka shaping engine).

=== debian/rules ===
#!/usr/bin/make -f

# Needed for glib-mkenums to work with UTF-8 input
export LC_ALL=C.UTF-8

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,-O1 -Wl,-z,defs
export DPKG_GENSYMBOLS_CHECK_LEVEL = 4

%:
	dh $@ --buildsystem=meson --without autoreconf

override_dh_auto_configure:
	dh_auto_configure --builddir build-main -- -Dauto_features=enabled -Dgraphite2=enabled
	dh_auto_configure --builddir build-udeb -- -Dauto_features=enabled -Dgraphite2=disabled -Dchafa=disabled

override_dh_auto_clean:
	dh_auto_clean --builddir build-main
	dh_auto_clean --builddir build-udeb

override_dh_auto_build:
	dh_auto_build --builddir build-main
	dh_auto_build --builddir build-udeb

override_dh_auto_test:
	dh_auto_test --builddir build-main
	dh_auto_test --builddir build-udeb

override_dh_auto_install:
	dh_auto_install --builddir build-main

override_dh_install:
	dh_install --exclude=subset

override_dh_makeshlibs:
	dh_makeshlibs --add-udeb="libharfbuzz0-udeb"

## harfbuzz 8.0.0

=== debian/changelog ===
harfbuzz (8.0.0-3) unstable; urgency=medium

  * Add subset-Fix-cast-align-issue.patch to fix cast-align issue.
    Fixes build on 32-bit ARM archs

 -- أحمد المحمودي (Ahmed El-Mahmoudy) <aelmahmoudy@users.sourceforge.net>  Wed, 12 Jul 2023 05:27:57 +0200

harfbuzz (8.0.0-2) unstable; urgency=medium

  [ Jeremy Bicha ]
  * Drop obsolete Files-Excluded.
    As was pointed out in the below commit, the 2 files
    are no longer provided in the latest releases of HarfBuzz
    Revert "Fill in d/copyright, and also bump version string w/ +dfsg"
    This partially reverts commit 040799cd82759f57a0cfcbf40e4cc7a1d77a5a0a.

  [ أحمد المحمودي (Ahmed El-Mahmoudy) ]
  * Drop invalid-language-zero.patch as it resulted in an API change causing
    other (C++) packages to FTBFS (Closes: #1040872)

 -- أحمد المحمودي (Ahmed El-Mahmoudy) <aelmahmoudy@users.sourceforge.net>  Wed, 12 Jul 2023 02:47:25 +0200

harfbuzz (8.0.0-1) unstable; urgency=medium

  * New upstream version 8.0.0
    - Fixes FTBFS with GCC-13 (Closes: #1037687)
    - Includes fix for CVE-2023-25193 (Closes: #1030612)
    - Pass libharfbuzz as positional parameter for GIR generation
      (Closes: #1039498)
  * Update copyright years
  * Drop fix-tests.patch, applied upstream
  * Add libharfbuzz-cairo0 package
  * Update symbols' files
  * Add invalid-language-zero.patch to remove typecast from
    HB_LANGUAGE_INVALID definition.
    Thanks to James Addison <jay@jp-hosting.net> (Closes: #1035669)
  * d/libharfbuzz0b.symbols: update symbols

 -- أحمد المحمودي (Ahmed El-Mahmoudy) <aelmahmoudy@users.sourceforge.net>  Mon, 10 Jul 2023 04:00:02 +0200

## harfbuzz 8.0.1

=== debian/changelog ===
harfbuzz (8.0.1-1+rb1) unstable; urgency=medium

  * New upstream version 8.0.1
  * Drop subset-Fix-cast-align-issue.patch, applied upstream
  * Update copyright holders

 -- أحمد المحمودي (Ahmed El-Mahmoudy) <aelmahmoudy@users.sourceforge.net>  Wed, 12 Jul 2023 22:45:57 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: أحمد المحمودي (Ahmed El-Mahmoudy) <aelmahmoudy@users.sourceforge.net>
 Uploaders: Emilio Pozuelo Monfort <pochu@debian.org>
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Build-Depends:
  debhelper-compat (= 13),
  dh-sequence-gir,
@@ -76,6 +76,8 @@
  libharfbuzz0b (= ${binary:Version}),
  libharfbuzz-icu0 (= ${binary:Version}),
  libharfbuzz-gobject0 (= ${binary:Version}),
+ libharfbuzz-subset0 (= ${binary:Version}),
+ libharfbuzz-cairo0 (= ${binary:Version}),
  gir1.2-harfbuzz-0.0 (= ${binary:Version}),
  libglib2.0-dev,
  libgraphite2-dev,
@@ -98,6 +100,28 @@
  .
  This package contains a command line interface for the HarfBuzz library.
 
+Package: libharfbuzz-subset0
+Multi-Arch: same
+Architecture: any
+Depends: ${misc:Depends}, ${shlibs:Depends}
+Description: OpenType text shaping engine (subset library)
+ HarfBuzz is an implementation of the OpenType Layout engine (aka layout
+ engine) and the script-specific logic (aka shaping engine).
+ .
+ This package contains the library for subsetting fonts. Subsetting reduces
+ codepoint coverage of font files and removes unnecessary data.
+
+Package: libharfbuzz-cairo0
+Architecture: any
+Multi-Arch: same
+Depends: ${misc:Depends}, ${shlibs:Depends}
+Pre-Depends: ${misc:Pre-Depends}
+Description: OpenType text shaping engine Cairo backend
+ HarfBuzz is an implementation of the OpenType Layout engine (aka layout
+ engine) and the script-specific logic (aka shaping engine).
+ .
+ This package contains the Cairo backend.
+
 Package: libharfbuzz-doc
 Section: doc
 Architecture: all
